<?php

namespace App\Http\Controllers;

use App\Models\Unit;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class UnityController extends Controller
{
    /**
     * Liste des unités.
     */
    public function index()
    {
        $units = Unit::orderBy('created_at', 'desc')->with('user')
            ->whereDeletedAt(null)->paginate(10);
        return view('units.index', compact('units'));
    }

    /**
     * Ajout d'une unité.
     */
    public function store(Request $request)
    {
        $validated = $request->validate([
            'name' => 'required|string|max:255',
            'abbreviation' => 'required|string|max:15',
            'description' => 'nullable|string|max:155',
        ]);

        $validated['user_id'] = Auth::id();
        $unit = Unit::create($validated);
        return redirect()->route('units.index')->with('success', 'Unité créée avec succès');
    }

    /**
     * Mise à jour de l'unité
     */
    public function update(Request $request, string $id)
    {
        $validated = $request->validate([
            'name' => 'required|string|max:255',
            'abbreviation' => 'required|string|max:15|unique:units',
            'description' => 'nullable|string|max:155',
        ]);

        $unit = Unit::find($id);
        $unit->update($validated);
        return redirect()->route('unit.index')->with('success', 'Unité modifiée avec succès');
    }

    /**
     * Suppression de l'unité
     */
    public function destroy(string $id)
    {
        $unit = Unit::find($id);
        $unit->delete();
        return redirect()->route('unit.index')->with('success', 'Unité supprimée avec succès');
    }
}